/* Vale Header v.1.0
by Griffin Knodle, a.k.a. Jair, 8/26/98
E-mail: gknodle@trinity.edu
http://www.resnet.trinity.edu/users/gknodle/

CONTENTS

long int hexInput()
   - Function used in Relative Searcher, Graphics Extractor, etc. to allow decimal
   or hexadecimal input.

TERMS OF USE

This program is distributed with its source code. You may use,
distribute, and modify it freely. Only two restrictions: These terms of use 
must stay the same, and you must always include the source code with the
program. Oh, and I'd appreciate it if you credit me as the original
author.*/

#include <stdio.h>
#include <conio.h>

long int hexInput(){
  long int value=0;
  char hexFlag=0;
  char negFlag=0;
  char input[10];
  int charsRead=0;
  int x;

  for(charsRead=0; charsRead < 10; charsRead++){

  input[charsRead]=getch();

  if(input[charsRead]==13 && charsRead > 0){
    printf("\n");
    break; // enter
    }

  if(input[charsRead]==8){ //backspace
    charsRead--;
    if(charsRead==-1 && negFlag==1){
      negFlag=0;
      printf("%c",8);
      }
    if(charsRead==-1) continue; //not if nothing to erase
    if(hexFlag==1) hexFlag=0; // erase H
    else{ // or erase last digit
      charsRead--;
      }
    printf("%c",8);
    continue;
    }
     
  if(hexFlag==1){ // after typing H, only backspace or enter
    charsRead--;
    continue;
    }

  if(input[charsRead]=='h' || input[charsRead]=='H'){  // set H
    charsRead--;
    if(charsRead==-1) continue; // not if no value yet
    hexFlag=1;
    printf("h");
    continue;
    }
  if(input[charsRead]=='-'){ // set neg
    charsRead--;
    if(charsRead > -1) continue; // only at start
    if(negFlag==1) continue; // once is enough
    negFlag=1;
    printf("-");
    continue;
    }
  if(input[charsRead] > 96 && input[charsRead] < 103)
    input[charsRead] -= 32; // a-f -> A-F
  if(input[charsRead] > 64 && input[charsRead] < 71){
    printf("%c",input[charsRead]);
    continue;
    }
  if(input[charsRead] > 47 && input[charsRead] < 58){
    printf("%c",input[charsRead]);
    continue;
    }
  charsRead--;
  }

  if(hexFlag==0){
    for(x=0; x<charsRead; x++){
      if(input[x] > 64 && input[x] < 71){
	hexFlag=1;
	break;
	}
      }
    }

  for(x=0; x < charsRead; x++){ 
    if(hexFlag==1) value *= 16;
    else value *= 10;
    if(input[x] > 47 && input[x] < 58){// digit 0-9
      value += (input[x] - 48);
      }
    if(input[x] > 64 && input[x] < 71){ // hex digit A-F
      value += (input[x] - 55);
      }
    }

  if(negFlag==1) value = (-value);

  //printf("\n%li",value);
  return value;
  }